/*
 * File Name: 		NativeOcr.java
 * 
 * Copyright(c) 2011 Yunmai Co.,Ltd.
 * 
 * 		 All rights reserved.
 * 					
 */

package com.ym.idcard.reg;


import com.yunmai.cc.idcard.controler.OcrConstant;

import android.os.Build;
import android.os.Handler;
import android.util.Log;




/**
 * 识别引擎接口定义
 * @author fangcm 2013-08-28
 *
 */
public class NativeOcr {
	
	
	private static final String LIB = "IDCardengine";
	private static final String LIB_R10 = "IDCardengine_r10";
	static {
		try {
//			if(Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP){
//				System.loadLibrary(LIB_R10);
//			}else{
				System.loadLibrary(LIB);
//			}
			
		} catch (Exception e) {
		}
	}
	

	private static Handler mHandler;
	public NativeOcr() {}
	public NativeOcr(Handler handler) {
		this.mHandler = handler;
	}

	public native int freeImage(long pEngine, long[] ppImage);
	public native int closeOCR(long[] ppEngine);
//	public native long SaveImageJpg(long pImage, byte[] filename);
	
	
	
	public native long GetCardNum(byte[] num,int size);
	
	public native long GetTrnImageThread();
	
	public native int GetCardNumRectThread(int[] rect);
	
	public native int GetCharInfoThread(int[] charinfo,int size);
	
	public native int GetCardBinInfo(long pEngine , byte[] result,int size);
	public native int LicenseStr(byte[] str);
	
//	public native int RecYuvImg(byte[] yuvBuffer,int witdh, int height,int[] rect);
	public native int RecYuvImg(byte[] yuvBuffer,int witdh, int height,int[] rect,byte[] license);
	
	public native int RecYuvImg(byte[] yuvBuffer,int witdh, int height,int[] rect,byte[] license,byte[] headPath,byte[] imgPath);
	
	
	public native int GetResult(byte[] resultInfo,int size);
	
	
	private static int GetState(int state){
		Log.d("tag", "-----state--1-------->"+state);
		
		switch (state) {
		case 1:
			mHandler.sendEmptyMessage(OcrConstant.RECOGN_OK);
			break;

		default:
			break;
		}
		return 1234;
	}
	
	
	
	
	
	private static int mProgress = 0;
	private static boolean mCancel = false;

	// ////////////////////////////////////////////////////
	// Constructor/Destructor

	

	@Override
	public void finalize() {

	}
	
	public static int getProgress() {
		return mProgress;
	}
	
	/**
	 * @param progress	进度值
	 * @param relative	1:progress表示前进进度值；	0:progress总进度值
	 * @return
	 */
	public static int Progress(int progress, int relative) {

		if (relative != 0) {
			mProgress += progress;
		} else {
			mProgress = progress;
		}
		
		return mProgress;
	}

	/**
	 * 初始化引擎
	 * @param ppEngine		引擎标识
	 * @param pDataPath		数据文件路径， 不为null
	 * @param pConfigFile	配置文件路径， 不为null
	 * @param nLanguage		识别语言
	 * @param license	
	 * @return
	 */
	public native int startBCR(long[] ppEngine, byte[] pDataPath,
			byte[] pConfigFile, int nLanguage, byte[] license);
	
	public native int startOCR(long[] ppEngine, byte[] pDataPath,
			byte[] pConfigFile, int nLanguage,int type);
	
	//北京电信专用
	public native int startBCRBeiJing(long[] ppEngine, byte[] pDataPath,
			byte[] pConfigFile, int nLanguage, byte[] license);

	/**
	 * 关闭识别引擎
	 * @param ppEngine	引擎标识
	 * @return
	 */
	public native int closeBCR(long[] ppEngine);

	/**
	 * 识别
	 * @param pEngine	引擎标识
	 * @param pImage	图像结构体标识
	 * @param ppField	返回首个字段的索引
	 * @return	0：失败	1：成功
	 */
//	public native int doImageBCR(long pEngine, long pImage, long[] ppField);
	
//	public native int doImageBCR(long pEngine, long pImage, long[] ppField,byte[] headPath);
	public native int doImageBCR(long pEngine, long pImage, long[] ppField,byte[] headPath,byte[] imgPath);
	
	public native int doLineOCR(long pEngine, long pImage, long[] ppField,byte[] buffer,int size);

	
	/**
	 * 模糊判断
	 * @param pEngine	引擎标识
	 * @param pImage	图像结构体标识
	 * @param level		0即可
	 * @return
	 */
	public native int imageChecking(long pEngine, long pImage, int level);
	
	public native int checkingCopyID(long pImage);

	/**
	 * 释放 条目/字段 资源
	 * @param pEngine	引擎标识
	 * @param pfield	字段ID，第一个或最后一个
	 * @param once		pfield是第一个，once必须为0；pfield是最后一个once必须为1
	 */
	public native void freeBField(long pEngine, long pfield, int once);

	/**
	 * 进度条相关
	 * 
	 * @param pEngine	引擎标识
	 * @param install	true：Progress(···)方法中返回进度值	false：无进度值 
	 */
	public native void setProgressFunc(long pEngine, boolean install); // fixxed

	/**
	 * 获取图像结构体
	 * @param pEngine	引擎标识
	 * @param pBuffer	图像流标识
	 * @param width		图像宽
	 * @param height	图像高
	 * @param component	图像通道（NativeImage.getImageComponent() 获得）
	 * @return	pImage
	 */
	public native long loadImageMem(long pEngine, long pBuffer, int width,
			int height, int component);

	/**
	 * 获取字段/条目 标识
	 * @param pField	字段ID
	 * @return	pField
	 */
	public native int getFieldId(long pField);

	/**
	 * 根据 字段/条目 标识 获取对于的信息
	 * @param pField	字段ID
	 * @param text		字段内容
	 * @param arraysize	第二个参数text申请的长度
	 * @return
	 */
	public native int getFieldText(long pField, byte[] /* out */text,
			int arraysize);
	
	/**
	 * 获取下一个 字段/条目 标识
	 * @param pField	当前字段ID
	 * @return	pField	下一字段ID
	 */
	public native long getNextField(long pField);
	
	/**
	 * 获取字段区域坐标
	 * @param pField
	 * @param rect		输出坐标
	 * @return
	 */
	public native int getFieldRect(long pField, int[] rect);
	
	/**
	 * 字符转换 ，仅限 识别语言是中文的时候转换
	 * 		中文简体  <---> 中文繁体
	 * @param pEngine	引擎标识
	 * @param text		in:原文 / out:转换后的
	 * @param key		3：GB2B5		
	 * @return
	 */
	public native int codeConvert(long pEngine, byte[] text, int key);
	
	/**
	 * 设置号码格式
	 * @param pEngine	引擎标识
	 * @param key		固定值“-fmt”
	 * @param pContent	null即可
	 * @return
	 */
	public native int setoption(long pEngine, byte[] key, byte[] pContent);
	
	
	public native int getLastErr(long pEngine, byte[] msg, int msgsize);
	

	public native long DupImage(long src, int[] rect);
	
	public native long getheadImgRect(long src, int[] rect);
	
	public native long SaveImage(long pImage, byte[] filename);
	
	public native int GetCardType(long pEngine,long pImage);
	
	public native long GetHeadInfo(int[] rect);
	
	public native int getheadImg(long pImage,long pField, byte[] filename);
	
	public native int ClearAll(int g_ClearAll);
	
	
	
	//-------新增自动拍照--
	public native int startBCR(long[] ppEngine, byte[] pDataPath,byte[] pConfigFile, int nLanguage);

	public native long getYData(byte[] pRgb565, int width, int height);
	
	public native byte CheckCardEdgeLine(long pEngine, long pImage,int[] rect, int threshold,int angle,int out,int in);
	
	public native byte[] BImageToImagebyte(long pImage);
	public native int BImageToImagebyte(long pImage,byte[] buffer);
	
	public native long YuvToRgb(byte[] yuvBuffer,int witdh, int height,int type);
	
	public native long FreeRgb(long yData);
	
	public native long SetSwitch(long  pEngine, int nSwitch, int mode);
	
}