package com.yunmai.android.other;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.security.MessageDigest;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.UUID;
import com.yunmai.android.vo.BSInfo;
import com.yunmai.android.vo.OperateActionInfo;
import android.content.Context;
import android.content.SharedPreferences;
import android.content.pm.ApplicationInfo;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.telephony.TelephonyManager;
import android.telephony.cdma.CdmaCellLocation;
import android.telephony.gsm.GsmCellLocation;
import android.util.Log;


public class LicenseManager {

	private final String TAG = "srvoperateM";
	private final long timeSpace = 1000001758l;
	private String time;
	private Context mContext;
	private TelephonyManager mTelephonyManager;
	private String license;
	private String step;
	private String uri = "http://uc.ccyunmai.com:6065/SrvOperate";
	private String oddString = "UerZ9\tReal@P1M*_#\r#";
	private String action = "insertmany";
	private SharedPreferences preferences;
	
	
	private String key_m = "<m>";
	private String key_m2 = "</m>";
	private String key_o = "<o>";
	private String key_o2 = "</o>";
	private String key_s = "<s>";
	private String key_s2 = "</s>";
	private String key_d = "<d>";
	private String key_d2 = "</d>";
	private String key_c = "<c>";
	private String key_c2 = "</c>";
	private String key_t = "<t>";
	private String key_t2 = "</t>";
	
	private StringBuffer desc = new StringBuffer("");
	private String imei = "";
	
	public LicenseManager(Context mContext){
		this.mContext = mContext;
		preferences = mContext.getSharedPreferences("licensekey",0);
	}
	
	public LicenseManager(Context mContext,String license,String step){
		this.mContext = mContext;
		this.license = license;
		this.step = step;
		preferences = mContext.getSharedPreferences("licensekey",0);
	}
	
	public void sendLicense(){
		try {
			time = new SimpleDateFormat("yyMMddHHmmSSS").format(new Date());
			
			long history = Long.parseLong(preferences.getString("time_key", "1"));
			if(Math.abs(Long.parseLong(time) - history) < timeSpace){
				return;
			}
			
			mTelephonyManager = (TelephonyManager) mContext.getSystemService(mContext.TELEPHONY_SERVICE);
			imei = mTelephonyManager.getDeviceId();
			PackageManager pm = mContext.getPackageManager();   
	        PackageInfo pi = pm.getPackageInfo(mContext.getPackageName(), 0);
			String versionName = pi.versionName;
//			int versionCode = pi.versionCode;
			String packageName = pi.packageName;
			ApplicationInfo applicationInfo = pi.applicationInfo;
			String appName = (String) pm.getApplicationLabel(applicationInfo);
			
//			 Log.d(TAG, "-----GetOcrResult--------->>"+time);
//			StringBuffer sb = new StringBuffer("");
//			sb.append(versionName).append("--");
//			sb.append(versionCode).append("--");
//			sb.append(packageName).append("--");
//			sb.append(appName).append("--");
//			sb.append(license);
//		    Log.d("tag", "-----tag-2-------->>"+sb.toString());
			
			BSInfo bsInfo = null;
			int netX = mTelephonyManager.getNetworkType();
//			Toast.makeText(mContext, "-->"+netX, Toast.LENGTH_LONG).show();
			try {
				 bsInfo = getBSInfo(netX);
			} catch (Exception e) {
				// TODO: handle exception
//				 Log.d(TAG, "-----tag-1-------->>"+e.toString());
			}
			desc.append(packageName).append("/");
			desc.append(versionName).append("/");
			desc.append(appName).append("/");
			if(bsInfo != null){
				desc.append("BsType : "+bsInfo.getBsType()).append("/");
				desc.append("cid : "+bsInfo.getCid()).append("/");
				desc.append("lac : "+bsInfo.getLac()).append("/");
				desc.append("mnc : "+bsInfo.getMnc()).append("/");
			}else{
				desc.append("BsType : 0").append("/");
				desc.append("cid : 0").append("/");
				desc.append("lac : 0").append("/");
				desc.append("mnc : 0").append("/");
			}
			desc.append(license.trim()).append("/");
//			desc.append(time).append("/");
//		    Log.d(TAG, "-----tag-2-------->>"+desc.toString());
			new Thread(){

				@Override
				public void run() {
					// TODO Auto-generated method stub
					
					OperateActionInfo OAInfo = new OperateActionInfo(step, desc.toString() ,"1");
					if(imei.equals("")){
						imei = "10000";
					}
				
					try {
						if(sendOneLog(URLEncoder.encode(getOneContent(OAInfo), "UTF-8"),imei)){
							preferences.edit().putString("time_key", time).commit();
						}
					} catch (Exception e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
			}.start();
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			 Log.d(TAG, "-----tag-2-------->>"+e.toString());
		}   
	}
	
	
	private BSInfo getBSInfo(int netX){
		BSInfo bsInfo = null;
//		Log.d("tag", "-------->>>"+netX);
		switch (netX) {
		case TelephonyManager.NETWORK_TYPE_1xRTT:
			
			break;
		case TelephonyManager.NETWORK_TYPE_CDMA://电信2G
			bsInfo = getCdmaBSInfo(mTelephonyManager);
			break;
		case TelephonyManager.NETWORK_TYPE_EDGE://移动联通2G
			bsInfo = getGsmBSInfo(mTelephonyManager);
			break;
		case TelephonyManager.NETWORK_TYPE_EVDO_0://电信	3G
			bsInfo = getCdmaBSInfo(mTelephonyManager);
			break;
		case TelephonyManager.NETWORK_TYPE_EVDO_A://电信3G
			bsInfo = getCdmaBSInfo(mTelephonyManager);
			break;
		case TelephonyManager.NETWORK_TYPE_GPRS: //GSM 1 移动联通2G
			bsInfo = getGsmBSInfo(mTelephonyManager);
			break;
		case TelephonyManager.NETWORK_TYPE_HSDPA://联通3G
			bsInfo = getGsmBSInfo(mTelephonyManager);
			break;
		case TelephonyManager.NETWORK_TYPE_HSPA:
			
			break;
		case TelephonyManager.NETWORK_TYPE_HSUPA:
			
			break;
		case TelephonyManager.NETWORK_TYPE_UMTS://联通3G
			bsInfo = getGsmBSInfo(mTelephonyManager);
			break;
		default:
//			bsInfo = getGsmBSInfo(mTelephonyManager);//默认GSM
			break;
		}
		return bsInfo;
	}
	
	private BSInfo getCdmaBSInfo(TelephonyManager tManager)
	{
		BSInfo bsInfo = new BSInfo();
		CdmaCellLocation mCdmaCellLocation = (CdmaCellLocation) tManager.getCellLocation();
		bsInfo.setBsType("1");
		bsInfo.setMcc("460");
		bsInfo.setMnc(String.valueOf(mCdmaCellLocation.getSystemId()));//cdma系统识别号码
		bsInfo.setCid(String.valueOf(mCdmaCellLocation.getBaseStationId()));//cdma基站识别码
		bsInfo.setLac(String.valueOf(mCdmaCellLocation.getNetworkId()));//cdma网络识别号码
		bsInfo.setNetType("cdma");
		DecimalFormat formater = new DecimalFormat("#0.######");
		bsInfo.setLat(String.valueOf(formater.format(mCdmaCellLocation.getBaseStationLatitude()/14400.0)));
		bsInfo.setLon(String.valueOf(formater.format(mCdmaCellLocation.getBaseStationLongitude()/14400.0)));
		
		return bsInfo;
	}
	
	
	private BSInfo getGsmBSInfo(TelephonyManager tManager)
	{
		BSInfo bsInfo = new BSInfo();
		GsmCellLocation mGsmCellLocation = (GsmCellLocation) tManager.getCellLocation();
		bsInfo.setBsType("2");
		bsInfo.setMcc("460");
		String netOperator = mTelephonyManager.getNetworkOperator();
//	    bInfo.setMcc(netOperator.substring(0, 3));
		bsInfo.setMnc(netOperator.substring(3, 5));
		bsInfo.setCid(String.valueOf(mGsmCellLocation.getCid()));
		bsInfo.setLac(String.valueOf(mGsmCellLocation.getLac()));
		bsInfo.setNetType("gsm");
		return bsInfo;
	}
	
	
	/**
	 * 组织单条记录
	 * @param oaInfo
	 * @return
	 */
	public String getOneContent(OperateActionInfo oaInfo){
		StringBuffer contentBuffer = new StringBuffer();
		contentBuffer.append(key_m);
		contentBuffer.append(key_o)
					 .append(key_s).append(oaInfo.getStep()).append(key_s2)
					 .append(key_d).append(oaInfo.getDesc()).append(key_d2)
					 .append(key_c).append(oaInfo.getCount()).append(key_c2)
					 .append(key_t).append(oaInfo.getTime()).append(key_t2)
					 .append(key_o2);
		contentBuffer.append(key_m2);
		return contentBuffer.toString();
	}
	
	
	/**
	 * 上传单个文件
	 * @param file
	 * @return
	 */
	private boolean sendOneLog(String content,String imei){
		boolean result = false;
		try {
			if(content != null && !content.equals("")){
//				Log.d(TAG, "<<------send-ok------>>"+content);
				URL url = new URL(uri);
				HttpURLConnection connection = (HttpURLConnection) url.openConnection();
				connection.setDoInput(true);
				connection.setDoOutput(true);
				connection.setConnectTimeout(7000);
				connection.setReadTimeout(7000);
				connection.setRequestMethod("POST");
				DataOutputStream dos = new DataOutputStream(connection.getOutputStream());
				dos.writeBytes(getParameters(content,imei));
				dos.flush();
				dos.close();
				if(connection.getResponseCode() == 200){
//					Log.d(TAG, "----send-ok----------->>"+file.getName());
					BufferedReader br = new BufferedReader(new InputStreamReader(connection.getInputStream()));
					StringBuffer respone = new StringBuffer();
					String xx;
					while ((xx = br.readLine()) !=null ) {
						respone.append(xx);
					}
//					if(respone != null && respone.toString().equals("1")){
//						result = true;
//					}
					if(respone != null && !respone.equals("-1")&& !respone.equals("-2")
							&& !respone.equals("-3")&& !respone.equals("-4")
							&& !respone.equals("-5")&& !respone.equals("-100")
							&& !respone.equals("-99")&& !respone.toString().trim().equals("")){
						result = true;
					}
//					Log.d(TAG, "----response----------->>"+respone);
				}else{
//					Log.d(TAG, "----send-faild------------->>"+file.getName());
				}
			}else{
//				Log.d(TAG, "----send-faild------------->>"+file.getName());
			}
		} catch (Exception e) {
			// TODO: handle exception
			Log.d(TAG, "<<------send-Exception------>>"+e.toString());
		}
		return result;
	}
	
	
	private String getParameters(String content,String imei){
		String rand = getUUID();
		StringBuffer result = new StringBuffer();
		result.append("action").append("=").append(action).append("&")
		.append("content").append("=").append(content).append("&")
		.append("imsi").append("=").append(imei).append("&")
		.append("loginid").append("=").append("").append("&")
		.append("mobile").append("=").append("").append("&")
		.append("rand").append("=").append(rand).append("&")
		.append("verify").append("=").append(getMd5(action + rand + oddString));
		return result.toString();
	}
	
	
	/**
	 * 获取UUID值
	 * 
	 * @return
	 */
	private String getUUID() {
		UUID uuid = UUID.randomUUID();
		return uuid.toString();
	}
	
	/**
	 * MD5 加密
	 * @param plainText	加密字符串
	 * @return
	 */
	private String getMd5(String plainText) {
		String result = "";
		try {
			MessageDigest md = MessageDigest.getInstance("MD5");
			md.update(plainText.getBytes());
			byte b[] = md.digest();
			int i;
			StringBuffer buf = new StringBuffer("");
			for (int offset = 0; offset < b.length; offset++) {
				i = b[offset];
				if (i < 0)
					i += 256;
				if (i < 16)
					buf.append("0");
				buf.append(Integer.toHexString(i));
			}
			result = buf.toString().toUpperCase();
//			return buf.toString();
		} catch (Exception e) {
			e.printStackTrace();
		}
//		Log.d(TAG, "------MD5---------------->>>"+result);
		return result;
	}
	
}
