package com.yunmai.android.vo;

import com.yunmai.android.engine.OcrEngine;

/**
 * 证件信息
 * 
 * @author Иεtwμ
 * 
 */
public class IDCard {

	public boolean isIDCard() {
		return isIDCard;
	}

	public void setIDCard(boolean isIDCard) {
		this.isIDCard = isIDCard;
	}

	/**
	 * 识别结果标识 ---》
	 * 
	 * -2 : 识别失败； -1 ： 取消识别； 0 ： do nothing； 1 ：识别成功； 2 ： 图像太小； 3 ： 图像模糊； 4 ：
	 * 识别语言错误；
	 */
	private int recogStatus = OcrEngine.RECOG_FAIL;

	// 证件信息
	private String ymName; // 姓名
	private String ymCardNo; // 证件号
	private String ymSex; // 性别
	private String ymEthnicity; // 名族
	private String ymBirth; // 出生
	private String ymAddress; // 住址
	private String ymAuthority; // 签发机关
	private String ymPeriod; // 有效期限
	private String ymMemo; // 备注
	private boolean isIDCard;

	/**
	 * @return 识别结果标识
	 */
	public int getRecogStatus() {
		return recogStatus;
	}

	public void setRecogStatus(int recogStatus) {
		this.recogStatus = recogStatus;
	}

	/**
	 * @return 姓名
	 */
	public String getName() {
		return ymName;
	}

	public void setName(String name) {
		this.ymName = name;
	}

	/**
	 * @return 证件号
	 */
	public String getCardNo() {
		return ymCardNo;
	}

	public void setCardNo(String cardNo) {
		this.ymCardNo = cardNo;
	}

	/**
	 * @return 性别
	 */
	public String getSex() {
		return ymSex;
	}

	public void setSex(String sex) {
		this.ymSex = sex;
	}

	/**
	 * @return 民族
	 */
	public String getEthnicity() {
		return ymEthnicity;
	}

	public void setEthnicity(String ethnicity) {
		this.ymEthnicity = ethnicity;
	}

	/**
	 * @return 出生
	 */
	public String getBirth() {
		return ymBirth;
	}

	public void setBirth(String birth) {
		this.ymBirth = birth;
	}

	/**
	 * @return 住址
	 */
	public String getAddress() {
		return ymAddress;
	}

	public void setAddress(String address) {
		this.ymAddress = address;
	}

	/**
	 * @return 签发机关
	 */
	public String getAuthority() {
		return ymAuthority;
	}

	public void setAuthority(String authority) {
		this.ymAuthority = authority;
	}

	/**
	 * @return 有效期限
	 */
	public String getPeriod() {
		return ymPeriod;
	}

	public void setPeriod(String period) {
		this.ymPeriod = period;
	}

	/**
	 * @return 备注
	 */
	public String getMemo() {
		return ymMemo;
	}

	public void setMemo(String memo) {
		this.ymMemo = memo;
	}

	@Override
	public String toString() {
		// TODO Auto-generated method stub
		StringBuffer strBuf = new StringBuffer();
		strBuf.append("是否身份证：").append(isIDCard).append("\n");
		strBuf.append("姓名：").append(ymName).append("\n");
		strBuf.append("性别：").append(ymSex).append("\n");
		strBuf.append("民族：").append(ymEthnicity).append("\n");
		strBuf.append("出生：").append(ymBirth).append("\n");
		strBuf.append("身份号码：").append(ymCardNo).append("\n");
		strBuf.append("住址：").append(ymAddress).append("\n");
		strBuf.append("签发机关：").append(ymAuthority).append("\n");
		strBuf.append("有效期限：").append(ymPeriod).append("\n");
		return strBuf.toString();
	}

	public String getIdCardText2() {
		// TODO Auto-generated method stub
		StringBuffer strBuf = new StringBuffer();
		strBuf.append("cardType：").append("二代身份证").append("\r\n");
		strBuf.append("Name：").append(ymName).append("\r\n");
		strBuf.append("CardNo.：").append(ymCardNo).append("\r\n");
		strBuf.append("Sex：").append(ymSex).append("\r\n");
		strBuf.append("Birthday：").append(ymBirth).append("\r\n");
		strBuf.append("Address：").append(ymAddress).append("\r\n");
		strBuf.append("Folk：").append(ymEthnicity).append("\r\n");
		strBuf.append("IssueAuthority：").append(ymAuthority).append("\r\n");
		strBuf.append("ValidPeriod：").append(ymPeriod).append("\r\n");
		return strBuf.toString();
	}

}
