package com.yunmai.cc.idcard.controler;



import java.io.IOException;
import java.io.InputStream;

import android.content.Context;
import android.content.res.AssetManager;
import android.graphics.Rect;
import android.os.Handler;
import android.util.Log;

import com.yunmai.cc.idcard.engine.OcrEngine;
import com.yunmai.cc.idcard.vo.IdCardInfo;

/**
 * ʶ
 * @author fangcm 2013-03-22
 *
 */
public class OcrManager {

	private String TAG ="ocr_manager";
	private OcrEngine ocrEngine;
	private Handler mHandler;
	private byte[] license;
	public OcrManager(Handler handler,Context context){
		this.mHandler = handler;
		ocrEngine = new OcrEngine(mHandler);
		
		license = new byte[256];
		AssetManager assetManager = context.getAssets();
		try {
			InputStream is= assetManager.open("license.info");
			is.read(license);
			is.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
		}
	}
	
	
	public void closeEngine(){
		ocrEngine.closeOCR();
	}
	
	
	
	
	public void recognBC(byte[] imgBuffer,int yuvWidth,int yuvHeight,Rect rect){
		Log.d("tag", "------start----");
		int result = ocrEngine.RecYuvImg(imgBuffer,yuvWidth, yuvHeight,rect,license);
		if(result == 100){
			mHandler.sendEmptyMessage(OcrConstant.RECOGN_EG_TIME_OUT);
		}else if(result == 200){
			mHandler.sendEmptyMessage(OcrConstant.RECOGN_EG_LICENSE);
		}else if(result < 0){
			mHandler.sendEmptyMessage(OcrConstant.RECOGN_EG_INIT_ERROR);
		}else{
			mHandler.sendMessage(mHandler.obtainMessage(OcrConstant.RECOGN_LINE_IN_RECT,result));
		}
		
		Log.d("tag", "------end---->"+result);
	}
	
	
	private void recognBC(byte[] imgBuffer,int yuvWidth,int yuvHeight,Rect rect,String imgHead,String imgPath){
		Log.d("tag", "------start----");
		int result = ocrEngine.RecYuvImg(imgBuffer,yuvWidth, yuvHeight,rect,license,imgHead,imgPath);
		if(result == 100){
			mHandler.sendEmptyMessage(OcrConstant.RECOGN_EG_TIME_OUT);
		}else if(result == 200){
			mHandler.sendEmptyMessage(OcrConstant.RECOGN_EG_LICENSE);
		}else if(result < 0){
			mHandler.sendEmptyMessage(OcrConstant.RECOGN_EG_INIT_ERROR);
		}else{
			mHandler.sendMessage(mHandler.obtainMessage(OcrConstant.RECOGN_LINE_IN_RECT,result));
		}
		
		Log.d("tag", "------end---->"+result);
	}
	
//	private String getNum(){
//		return ocrEngine.GetCardNum();
//	}
	
	public IdCardInfo getResult(String imgPath,String headPath){
		IdCardInfo idCardInfo = new IdCardInfo();
		
		Log.d("tag", "-------result-4----->>");
		byte[] charInfo = new byte[1024];
		ocrEngine.GetResult(charInfo);
		Log.d("tag", "-------result-4-1---->>"+ charInfo.toString());
		int[] rect = new int[4];
		long pImage = ocrEngine.GetHeadInfo(rect);
		ocrEngine.saveImgJpg(pImage, imgPath);
		Log.d("tag", rect[0]+"<----->>"+rect[1]);
		if(rect[0] != 0){
			long pImageRect = ocrEngine.DupImage(pImage, rect);
			ocrEngine.saveImgJpg(pImageRect, headPath);
			idCardInfo.setHeadPath(headPath);
		}else{
			idCardInfo.setHeadPath("");
		}
		
		idCardInfo.setImgPath(imgPath);
		
		idCardInfo.setCharInfo(charInfo);
		
		
		
		return idCardInfo;
	}
	
	
	public void clearAll(){
		ocrEngine.clearAll(1);
	}
	
	
	public String getLicense(){
		return ocrEngine.getLicense();
	}
}
