/*
 * File Name: 		OcrEngine.java
 * 
 * Copyright(c) 2011 Yunmai Co.,Ltd.
 * 
 * 		 All rights reserved.
 * 					
 */

package com.yunmai.cc.idcard.engine;

import java.io.UnsupportedEncodingException;


import com.ym.idcard.reg.NativeOcr;
import com.yunmai.android.other.StringUtil;
import com.yunmai.cc.idcard.controler.StringManager;

import android.graphics.Rect;
import android.os.Handler;
import android.util.Log;



public class OcrEngine {
	
	
	// member variables
	protected long[] m_ppEngine = null;
	protected long[] m_ppImage = null;
	protected long[] m_ppField = null;
	protected long m_pEngine = 0;
	protected long m_pImage = 0;
	protected long m_pField = 0;
	protected long m_pCurField = 0;
	protected NativeOcr mOcr = null;
	

	public OcrEngine(Handler handler) {
		m_ppEngine = new long[1];
		m_ppImage = new long[1];
//		m_ppField = new long[1];
		mOcr = new NativeOcr(handler);
	}

	@Override
	public void finalize() {
		m_ppEngine = null;
		m_ppImage = null;
		m_ppField = null;
		mOcr = null;

		m_pEngine = 0;
		m_pImage = 0;
		m_pField = 0;
	}


	public void closeOCR() {
		if (m_ppEngine != null && mOcr != null) {
			mOcr.closeOCR(m_ppEngine);
			m_ppEngine[0] = 0;
			m_pEngine = 0;
		}
	}


	public void freeImage() {
		if (mOcr != null) {
			mOcr.freeImage(m_pEngine, m_ppImage);
			m_ppImage[0] = 0;
			m_pImage = 0;
		}
	}
	
	
	public void saveImgJpg(long pImage,String filePath){
		if(mOcr != null){
			StringBuffer s = new StringBuffer(filePath);
			s.append('0');
			byte[] buffer = null ;
			try {
				buffer = s.toString().getBytes("gbk");
			} catch (UnsupportedEncodingException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			buffer[buffer.length - 1] = 0; 
			
			mOcr.SaveImage(pImage, buffer);
		}
	}
	
	public void saveImgJpg(String filePath){
		if(mOcr != null){
			StringBuffer s = new StringBuffer(filePath);
			s.append('0');
			byte[] buffer = null ;
			try {
				buffer = s.toString().getBytes("gbk");
			} catch (UnsupportedEncodingException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			buffer[buffer.length - 1] = 0; 
			
			mOcr.SaveImage(m_pImage, buffer);
		}
	}
	
	



	
	
	
	
	
	public int RecYuvImg(byte[] yuvBuffer,int witdh, int height,Rect rect,byte[] license,String headPath,String imgPath){
		int r[] = new int[4];
		r[0] = rect.left;
		r[1] = rect.top;
		r[2] = rect.right;
		r[3] = rect.bottom;
		byte[] bufferH = StringUtil.convertUnicodeToGbk(headPath);
		byte[] bufferI = StringUtil.convertUnicodeToGbk(imgPath);
		int result = mOcr.RecYuvImg(yuvBuffer, witdh, height,r,license,bufferH,bufferI);
		return result;
	}
	
	public int RecYuvImg(byte[] yuvBuffer,int witdh, int height,Rect rect,byte[] license){
		int r[] = new int[4];
		r[0] = rect.left;
		r[1] = rect.top;
		r[2] = rect.right;
		r[3] = rect.bottom;
		int result = mOcr.RecYuvImg(yuvBuffer, witdh, height,r,license);
		return result;
	}
	
	public String GetCardNum(){
		byte[] num = new byte[32];
		mOcr.GetCardNum(num, num.length);
		return new String(num);
	}
	
	public long  GetTrnImageThread(){
		return mOcr.GetTrnImageThread();
	}
	
	public int GetCardNumRectThread(int[] rect){
		return mOcr.GetCardNumRectThread(rect );
	}
	
	public int GetCharInfoThread(int[] charInfo){
		int ret = 0;
		ret = mOcr.GetCharInfoThread(charInfo, charInfo.length);
//		if(ret > 0){
//			
//		}
		return ret;
	}
	
	public int GetResult(byte[] charInfo){
		int ret = 0;
		ret = mOcr.GetResult(charInfo, charInfo.length);
//		if(ret > 0){
//			
//		}
		return ret;
	}
	
	public int GetCardBinInfo(byte[] binInfo){
		int ret = 0;
		ret = mOcr.GetCardBinInfo(m_pEngine, binInfo, binInfo.length);
		Log.d("tag", "--x-bin-------->>"+ret);
		return ret;
	}
	
	public long GetHeadInfo(int[] rect){
		return mOcr.GetHeadInfo(rect);
	}
	
	
	public long DupImage(long pImage,int[] rect){
		long result = -1;
		if(mOcr != null){
			result = mOcr.DupImage(pImage, rect);
		}
		return result;
	}
	
	
	public String getLicense(){
		String result = "";
		byte[] b = new byte[1024];
		int key = mOcr.LicenseStr(b);
		try {
			result = new String(b, "gbk");
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			result = e.toString();
			e.printStackTrace();
		}
//		List<String> list = new ArrayList<String>();
//		list.add(result);
//		list.add(String.valueOf(key));
		return result;
	}
	
	public void clearAll(int g_ClearAll){
		mOcr.ClearAll(g_ClearAll);
	}
	
}